"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.debounce = void 0;
function debounce(callback, timeout = 0) {
    let timer;
    let resolve;
    let promise = createPromise();
    function createPromise() {
        return new Promise((_resolve, _reject) => {
            resolve = (...args) => {
                promise = createPromise();
                let value;
                try {
                    value = callback(...args);
                }
                catch (e) {
                    _reject(e);
                    return;
                }
                _resolve(value);
            };
        });
    }
    return (...args) => {
        clearTimeout(timer);
        timer = setTimeout(() => resolve(...args), timeout);
        return promise;
    };
}
exports.debounce = debounce;
